Public Class Form1

   Dim syncByte As Long = 127

   Dim WithEvents serialPort As New IO.Ports.SerialPort

   Private Sub Form1_Load(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles MyBase.Load

      For i As Integer = 0 To My.Computer.Ports.SerialPortNames.Count - 1
         cboCOMPorts.Items.Add(My.Computer.Ports.SerialPortNames(i))
      Next
      btnDisconnect.Enabled = False

      For Pins As Integer = 0 To 15
         cboPinNumber.Items.Add(CStr(Pins))
      Next
      cboPinNumber.SelectedIndex = 0
      optStateLow.Checked = True

   End Sub

   Private Sub DataReceived(ByVal sender As Object, _
      ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles serialPort.DataReceived

      txtDataReceived.Invoke(New myDelegate(AddressOf updateTextBox), New Object() {})

   End Sub

   

   Public Delegate Sub myDelegate()

   Public Sub updateTextBox()

      With txtDataReceived
         .Font = New Font("Garamond", 12.0!, FontStyle.Bold)
         .SelectionColor = Color.Red
         .AppendText(serialPort.ReadExisting)
         .ScrollToCaret()
      End With

   End Sub

   Private Sub btnConnect_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnConnect.Click

      If serialPort.IsOpen Then
         serialPort.Close()
      End If

      Try
         With serialPort
            .PortName = cboCOMPorts.Text
            .BaudRate = 9600
            .Parity = IO.Ports.Parity.None
            .DataBits = 8
            .StopBits = IO.Ports.StopBits.One
         End With
         serialPort.Open()

         lblMessage.Text = cboCOMPorts.Text & " connected."
         btnConnect.Enabled = False
         btnDisconnect.Enabled = True
         cmdSend.Enabled = True
         txtDataReceived.Clear()
      Catch ex As Exception
         MsgBox(ex.ToString)
      End Try

   End Sub

   Private Sub btnDisconnect_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnDisconnect.Click

      Try
         serialPort.Close()
         lblMessage.Text = serialPort.PortName & " disconnected."
         btnConnect.Enabled = True
         btnDisconnect.Enabled = False
         cmdSend.Enabled = False
      Catch ex As Exception
         MsgBox(ex.ToString)
      End Try

   End Sub

   Private Sub cmdSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSend.Click
      Dim PinNumber, PinState As Integer

      ' Get Pin number
      PinNumber = cboPinNumber.SelectedIndex

      ' Get Pin State
      If optStateLow.Checked = True Then
         PinState = 0
      Else
         PinState = 1
      End If

      ' Send Out the Data
      serialPort.Write(Chr(syncByte) & Chr(PinNumber) & Chr(PinState))

   End Sub

End Class

